--- old/usr/src/cmd/prstat/prtable.c	Wed Apr  3 09:33:11 2013
+++ new/usr/src/cmd/prstat/prtable.c	Wed Apr  3 09:33:11 2013
@@ -19,6 +19,8 @@
  * CDDL HEADER END
  */
 /*
+ * Copyright (c) 2013 Gary Mills
+ *
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  *
@@ -59,14 +61,21 @@
 }
 
 void
-pwd_getname(uid_t uid, char *name, int length, int noresolve)
+pwd_getname(uid_t uid, char *name, size_t length, int noresolve,
+    int termcap, size_t width)
 {
 	struct passwd *pwd;
+	size_t n;
 
 	if (noresolve || (pwd = getpwuid(uid)) == NULL) {
 		(void) snprintf(name, length, "%u", uid);
 	} else {
-		(void) snprintf(name, length, "%s", pwd->pw_name);
+		n = strlen(pwd->pw_name);
+		if (termcap && n > width)
+			(void) snprintf(name, length, "%.*s%c",
+			    width - 1, pwd->pw_name, '*');
+		else
+			(void) snprintf(name, length, "%s", pwd->pw_name);
 	}
 }
 
